#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <time.h>
#include "serial.h"
#define BLOCKSIZE 4096 // 500
#define L_OK	0
#define L_FAIL	-1


int giPort=1;
int gLog=1;

typedef	union swapdata
	{
		unsigned short sum;
		unsigned char retsum[2];
	} SWAPDATA;

void GetDayTime(long *lYear,long *lMon,long *lDay,long *lHour,long *lMin,long *lSec)
{
	time_t timep;
	struct tm *p;

	time(&timep);
	p=localtime(&timep);
	*lYear =1900+p->tm_year;
	*lMon=1+p->tm_mon;
	*lDay =p->tm_mday;
	*lHour =p->tm_hour;
	*lMin = p->tm_min;
	*lSec = p->tm_sec;
}

void Log(char *szlog)
{
	FILE *fpw;
	if ((fpw=fopen("log.txt","a"))==NULL)
	{
		printf("日志文件出错!\r\n");
		return ;
	}
	fwrite(szlog,1,strlen(szlog),fpw);
	fclose(fpw);
}

int Connect(int iPort,int iBaud,int iDataBit)
{
  if (IO_InitializePort(iBaud,iDataBit,'N',iPort))
  {
      return L_OK;
  }
	return L_FAIL;
}


int Disconnect()
{
  if (IO_Close())
    return L_OK;

  else
    return L_FAIL;
}


int GetStatus(unsigned char *pRData,int RLen)
{
	int readed=0;
	if (RLen<1) return L_FAIL;
	pRData[0]=0;
//	pRData[1]=1;
	IO_Read(pRData,RLen,3000);
	if ( readed>0 )
	{
		return L_OK;
	}
	return L_FAIL;
}


int WriteComm(unsigned char *cmd,int cmdlen)
{
  if (!IO_Write(cmdlen,cmd))
	return L_FAIL;

	return L_OK;
}



unsigned short GetSum(unsigned char *pdata,long len)
{
	unsigned short sum=0;
	long i;
	for (i=0;i<len;i++)
	{
		sum+=((unsigned char)pdata[i]%256);
		sum &=0XFFFF;
	}
	return (sum&0XFFFF);
}




int  main(int argc ,char* argv[])
{
	int port,baud;
	char szValue[256],szPort[10],szFile[256],szPwd[10],szTimeout[10];
	int filelen=0;
	int i=0;
	size_t st=0;
	unsigned short sum=0;
	FILE *fpr;
	unsigned char buf[BLOCKSIZE+1];
	unsigned char bFirstPack=1;
	unsigned char m_bSuc=0;
	int iret=0;
	unsigned char cmd[100];
	char szlog[500];
	int dwSize=0;
	//int retsum=0;
   long iSended=0;
	long lYear,lMon,lDay,lHour,lMin,lSec;
	SWAPDATA retsum;
  int icount=0;

	long iBaud[]=
	{
		4800,
		9600,
		19200,
		38400,
		57600,
		115200
	};



	GetDayTime(&lYear,&lMon,&lDay,&lHour,&lMin,&lSec);
	sprintf(szlog,"%.4d-%.2d-%.2d %.2d:%.2d:%.2d=>enter programm\r\n",lYear,lMon,lDay,lHour,lMin,lSec);
	Log(szlog);

	printf("\n      ***<<Icod test software>>***\r\n\n");

	printf("please input the port no.(COM1,input 1 ,and return)\r\n");
	scanf("%[0-9]s",szPort);
	printf("please input the baud rate:\r\n");
	scanf("%s",szPwd);
//printf("请输入延时值，然后回车：%x\r\n",szPort[0]);
//scanf("%[0-9]s",szTimeout);

	if (szPort[0]==0)
	  port =1;
	else
	  port=atoi(szPort);
    if (szPwd[0]==0)
	  baud =38400;
	else
	  baud=atoi(szPwd);

	if (port<1 || baud < 1)
	{
		printf("port or baud error\r\n");
		  return 0;
	  }



  	if (Connect(port,baud,8)==L_OK) 
	{
	  printf("\nopen the commnunication OK\r\n\n");
	  }
	else
	{
	  printf("\nopen the commnunication Failed\r\n\n");
	  return 0;
	}



	sprintf(szlog,"Test Time:%.4d-%.2d-%.2d %.2d:%.2d:%.2d\n",lYear,lMon,lDay,lHour,lMin,lSec);
	WriteComm(szlog,strlen(szlog));
	sprintf(szlog,"apples                   $10.00\n");
	WriteComm(szlog,strlen(szlog));
	sprintf(szlog,"grapes                   $20.00\n");
	WriteComm(szlog,strlen(szlog));
	sprintf(szlog,"bananas                 $30.00\n");
	WriteComm(szlog,strlen(szlog));
	sprintf(szlog,"lemons                  $40.00\n");
	WriteComm(szlog,strlen(szlog));
	sprintf(szlog,"total                   $100.00\n");
	WriteComm(szlog,strlen(szlog));
	cmd[0]=0x1D;
	cmd[1]=0x56;
	cmd[2]=0x42;
	cmd[3]=0x00;
	WriteComm(cmd,4);
	Disconnect();
	return 0;
}
