#ifndef serial_h
#define serial_h

/*
 *
 * NAME:
 *	serial.h - Copyright (C) 1998 David Corcoran
 *             corcordt@cs.purdue.edu
 *
 * DESCRIPTION:
 *      This provides Unix serial interface drivers.
 *
 * AUTHOR:
 *	David Corcoran, 3/17/98
 *
 * LICENSE: See file COPYING
 *
 */

#include "LinuxDefines.h"

bool
IO_InitializePort(	/* Initialize the card reader port.	*/
	int baud,	/* Baud rate to set port to		*/
	int bits,	/* Bytesize: 5, 6, 7 or 8		*/
	char par,	/* Parity: 'E' even, 'O' odd, 'N' none	*/
  int port
//	char* port	/* Name of port, or (char *)0L for dialog */
);

HANDLE
IO_ReturnHandle(        /* Returns the current handle           */
	void
);

int 
IO_UpdateReturnBlock(   /* Returns the current blocking time    */
	int blocktime   /* The updated blocking time            */
);

int
IO_ReturnBaudRate(      /* Return the current baudrate          */
	void
);


char
IO_ReturnParity( 
	void            /*  Return the current parity  */
);

char
IO_UpdateParity(
	char parity	
); 

int
IO_ReturnStopBits(
        void            /*  Return stop bits  */
);

int
IO_UpdateStopBits(
        int stopbits
);


bool			/* True for sucess, false otherwise	*/
IO_FlushBuffer(		/* Flush buffer to card reader		*/
	void
);

int IO_Read(unsigned char *rdata,int len,int iTimeout);

bool    
IO_Write(
        int writesize,
	BYTE* c          /* Bytes to be written                   */
);

bool			/* True for success, false otherwise */
IO_Close(		/* On a Mac, gotta close the port */
	void
);

#endif
